function [a, r] = lpc_if(x, nlpc, wlen,wshft)

if rem(wlen,2)==1  
  wlen = wlen+1;
end
w     = hamming(wlen)';
nwin  = fix((length(x)-wlen+wshft)/wshft);

n = 0;
f = 1;

a  = zeros(nwin,nlpc+1);
r  = zeros(size(x));
wm = zeros(size(r)); % Will store weights for normalization
while n+wlen<=length(x)
  s = x(n+(1:wlen)).*w;
  a(f,:) = lpc(s,nlpc);

  r(n+(1:wlen))  = r(n+(1:wlen)) + filter(a(f,:),1,s);
  wm(n+(1:wlen)) = wm(n+(1:wlen)) + w;
  
  % This line would simply perform OLA on the original signal
  % r(n+(1:wlen))  = r(n+(1:wlen)) + s;

  n = n+wshft;
  f = f+1;
end

r = r./wm;